##### plot_simulation

rm(list=ls(all=TRUE))
setwd("H:\\fpca\\setup2")  # set the work directory
library(orthogonalsplinebasis)
library(expectreg)
library(splines)
library(fpca)
library(Matrix)
source("parameter2.r")
source("knots.r")
for(sim in 1:sim_n){
load(file=paste(".\\","sim",sim,"\\", "y_hat_indiv.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "alpha1.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "alpha2.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "f1.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "f2.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "mu.RData",sep=""))
load(file=paste(".\\","sim",sim,"\\", "estimate_final.RData",sep=""))

  mu.final<-estimate.final[[1]]
  theta.f<-estimate.final[[2]]
  alpha.final<-estimate.final[[3]]
  expectile.final<-estimate.final[[4]]
  mean.final<-estimate.final[[5]]
 expectile_theo1<-rep(0, M*N)
 dim(expectile_theo1)<-c(M,N)
  for(i in 1:N)
  expectile_theo1[,i]<-mu_x+f1_x*alpha1[i]+f2_x*alpha2[i]+enorm(p,sd=d3)
  mse1<-1/(M*N)*sum((expectile.final-expectile_theo1)^2)
  mse2<-1/(M*N)*sum((y_hat11-expectile_theo1)^2)
 
 mean.theo<-mu_x+enorm(p,sd=d3)
 mean.indiv<-rowMeans(y_hat11)

  mse_mean1<-(1/M)*sum((mean.theo-mean.final)^2)
  mse_mean2<-(1/M)*sum((mean.theo-mean.indiv)^2)

 MSE[sim,]<-c(mse1,mse2,mse_mean1,mse_mean2)
}
 save(MSE,file="MSE.RData")
#dev<-B%*%hat_theta2%*%t(hat_alpha2)
#dev_up<-rep(0, M)
#dev_down<-rep(0, M)

#for(i in 1:M)
#{dev_up[i]<-quantile(dev[i,],0.95)
#dev_down[i]<-quantile(dev[i,],0.05)
#}

 #matplot(x*M,expectile.final, type="l", lty=1, lwd=2,col=1:N)
#lines(x*M, mean.final, lwd=4, col=1)
#lines(x*M,mean.final+dev_up, lty=2, lwd=4, col=2)
#lines(x*M,mean.final+dev_down, lty=2, lwd=4, col=2)

#matplot(x*M,cbind(expectile_theo1[,15:20],expectile.final[,15:20],y_hat11[,15:20]),type="l", lty=1:3, lwd=2,col=rep(1:3,5),ylab="")
#matplot(x*M,cbind(mean.theo,mean.final,mean.indiv),type="l", lty=1:3, lwd=4,ylab="")

