# the first setup for the simulation


# this function is used to simulation data:

f1<-function(x){
 f1_x=sin(2*pi*x)/sqrt(0.5)
 return(f1_x)
}
f2<-function(x){
  f2_x=cos(2*pi*x)/sqrt(0.5)
  return(f2_x)
} 

y_sim<-function(x,m,n,sd1,sd2,sd3){   # x is the 
 mu_x<-1 + x + exp(-(x - 0.6)^2/0.05)
 alpha11<-rnorm(n,0,sd1)
 alpha21<-rnorm(n,0,sd2)
 alpha1<-alpha11-mean(alpha11)  # standardlize the coefficient to be mean 0. 
 alpha2<-alpha21-mean(alpha21)
 y<-rep(0,m*n)
 dim(y)=c(m,n)
 for (i in 1:n)
 {y[,i]=mu_x+f1(x)*alpha1[i]+f2(x)*alpha2[i]+rnorm(m,sd=sd3)}
 list(mu_x=mu_x,f1_x=f1(x),f2_x=f2(x),alpha1=alpha1, alpha2=alpha2,y=y)
}
