
# this is the main function
rm(list=ls(all=TRUE))
setwd("D:\\STUDY\\Research\\US\\temperature\\code_201107")
source("libraries.r")
p=0.95;  # the pth expectile we calculate
lambda1=500;
lambda2<-10;
#g=2 # the number of components we choose.
#y_hat11<-rep(0, m*n)
#dim(y_hat11)<-c(m,n)
#y_hat2<-rep(0, m*n)
#dim(y_hat2)<-c(m,n)
#y_hat11 stands for the single curve estimation by our algorithm.
#y_hat2 is the plug in method
#for (i in 1:n)
#{ 
#y_hat11[,i]<-fitwls_single(base,x,y[,i],p,lambda2)$fitted

indiv_y<-indiv(y,p, lambda2)
y_hat11<-indiv_y[[1]]
weight<-indiv_y[[2]]
#y_hat2[,i]<-expectile.laws(y[,i]~base(x,"pspline"), expectiles=p,lambda=lambda2)$fitted
#}

initial_est<-initial(y_hat11,g)
theta_mu2<-initial_est[[1]]
hat_theta2<-initial_est[[2]]
hat_alpha<-initial_est[[3]]
hat_alpha2<-hat_alpha

w1<-rep(0,m*n)
dim(w1)<-c(m,n)
mean_yhat1<-B%*%theta_mu2
mean_yhat<-rep(mean_yhat1,n)
dim(mean_yhat)<-c(m,n)
y_hat1<-mean_yhat+B%*%hat_theta2%*%t(hat_alpha2)
for (j in 1:n)
{w1[,j]= as.vector(ifelse(y[,j] > y_hat1[,j], p, 1-p))}
itt=100
max1=0.005
start<-Sys.time()
estimate_final<-estimate(y,w1,itt,max1,lambda1,lambda2)
theta_mu1<-estimate_final[[1]]
hat_theta1<-estimate_final[[2]]
hat_alpha1<-estimate_final[[3]]
max<-estimate_final[[4]]
it<-estimate_final[[5]]
end<-Sys.time()
end-start

mean_haty1<-B%*%theta_mu1
mean_haty2<-rep(B%*%theta_mu1,n)
dim(mean_haty2)<-c(m,n)
y_hat12<-mean_haty2+B%*%hat_theta1%*%t(hat_alpha1)

par(mfrow=c(4,5))
 for(i in 1:n)
 {mean_i<-mu_x+f1_x*alpha1[i]+f2_x*alpha2[i]+enorm(p,sd=sd3)
 plot(x,y_hat12[,i], type="p",pch=".", ylab="", ylim=range(c(y_hat12[,i],mean_i)))
lines(x,mean_i , col=2)
}

dev.off()
matplot(x,y_hat12, type="l", lty=1, lwd=3, col=1:n)
lines(x, mean_haty1, lwd=6, col=1)
plot(x,mean_haty1, lwd=1,col=2)
points(x,mu_x+enorm(p,sd=sd3))
