# this is the part to calculate the initial values
initial<-function(y_hat11,g,d,m,n,B){ #browser()
sum1<-rep(0,d*d)
 dim(sum1)<-c(d,d)
 sum2<-rep(0,d)
 theta_mu0<-rep(0,d)   
 ### (1)the estimation for $theta_mu$ 
 # do the linear regression for the initial mean curves:
for (i in 1:n){
sum2<-sum2+t(B)%*%y_hat11[,i]}
sum1<-n*t(B)%*%B
theta_mu0<-solve(sum1, sum2)
#browser()
#theta_mu0<-solve(t(B)%*%B, t(B)%*%y)
#theta_mu0<-lm(y~-1+B)$coef
mean_y1<-B%*%theta_mu0

mean_y11<-rep(mean_y1,n)
dim(mean_y11)<-c(length(mean_y1),n)
resid1_y<-y_hat11-mean_y11
gamma_1<-rep(0,d*n) 
dim(gamma_1)=c(d,n)
gamma_1<-solve(t(B)%*%B, t(B)%*%resid1_y)
### use svd to decompose the gamma, and choose the number of eigenfunctions.
svd_gamma<-svd(gamma_1)
#plot(svd_gamma$d)
#g<-2    # number of components we choose
theta_f<-svd_gamma$u[,1:g]
# base on the plot, we choose the first two components, and regress on gamma to get alpha's
hat_alpha<-rep(0,g*n)
dim(hat_alpha)<-c(n,g)
hat_alpha1<-rep(0,g*n)
dim(hat_alpha1)<-c(n,g)
# since theta_f keeps the same in all individual curves, we use pca to choose 2 most 
## important components, and do the regression to fix alpha.
for (i in 1:n)
{
##hat_alpha[i,]=lm(gamma_1[,i]~theta_f-1)$coefficients
hat_alpha1[i,]=solve(t(theta_f)%*%theta_f, t(theta_f)%*%gamma_1[,i])}
hat_alpha<-t(t(hat_alpha1)-apply(hat_alpha1,2,mean))
hat_theta=theta_f
#y_intial<-B%*%theta_mu0
return(list(theta_mu0,hat_theta, hat_alpha))}
